#!/usr/bin/perl
#!perl

use strict;
require 5.003;
use FindBin;
use lib $FindBin::Bin;
if ($ENV{'WINDIR'} ne undef) {
  chdir($FindBin::Bin);
}
use aolapi;
use cartapi;
require shutil;
print "Content-type: text/html\n\n";

my %INPUT;


header();
init();
my %VARS = aolapi::getvars();
my $accid = $INPUT{'accid'};
my %accnt = aolapi::getaccnt($accid);
my $name = 'customer';
$name = "$accnt{'name'} $accnt{'lname'}" if $accnt{'name'} ne undef;
print "<br>Dear $name,<br><br>Thank you for shopping in our store.<br><br>Your order:<br>\n" .
        "<table border=1><tr><td>Description</td><td>Qty</td><td>Subtotal</td></tr>\n";
my $total = 0;
my $vattotal = 0;
my $gsttotal = 0;
my $shtotal;
foreach my $item (split(/=and=/, $INPUT{'cart'})) {
  my ($prodid, $qty, $notes) = split(/:/, $item);
  $notes = cartapi::unpacknotes($notes);
  my %product = aolapi::getproduct($prodid);
  my $itemprice = $product{'setup'};
  $itemprice = -$itemprice if $product{'billtype'} eq 'DB';
  print "<tr><td>$product{'description'} $notes</td><td>$qty</td><td>" . sprintf("%.2f", $itemprice * $qty) . "</td></tr>\n";
  $total +=  $itemprice * $qty;
  my $vat = aolapi::vat($itemprice * $qty, $accid, $prodid);
  $vattotal += $vat;
  my $gst = aolapi::gst($itemprice * $qty + $vat, $accid, $prodid);
  $gsttotal += $gst;
  my $sh = 0;
  if ($VARS{'cart_sh'} ne undef) {
    $sh = $product{'handling'};
  }
  $sh *= $qty;
  $shtotal += $sh;
}
$gsttotal = sprintf("%.2f", $gsttotal);
$vattotal = sprintf("%.2f", $vattotal);
if ($shtotal ne undef) {
  $shtotal += shutil::cost($accid, $INPUT{'cart_delivery'});
}
$shtotal = sprintf("%.2f", $shtotal);
if ($vattotal > 0.01) {
  print "<tr><td colspan=\"2\"><b>VAT</b></td><td>" .  $vattotal . "</td></tr>\n";
}
if ($gsttotal > 0.01) {
  print "<tr><td colspan=\"2\"><b>Sales Tax</b></td><td>" .  $gsttotal . "</td></tr>\n";
}
if ($shtotal > 0.01) {
  print "<tr><td colspan=\"2\"><b>Shipping & Handling</b></td><td>" .  $shtotal . "</td></tr>\n";
}
$total += $vattotal + $gsttotal + $shtotal;
print "<tr><td colspan=\"2\"><b>Total</b></td><td>" .  sprintf("%.2f", $total) . "</td></tr></table><br><br>\n";
footer();
exit;

sub header {
print <<EOT;
<html>
<head>
<title>Ordering ACME Hosting</title>
<style type="text/css">
 BODY, P, UL, LI, FORM, table, td
    {        font-family: arial; color: #444444;
        font-size: 14px;      }
 h3   {        font-size: 14 px; color: #444444;}
 .title    { font-family: Geneva, Arial, Helvetica, sans-serif; font-size: 18pt; color: #222222; font-weight: bold; }
 .form    { font-family: Geneva, Arial, Helvetica, sans-serif; font-size: 10pt; color: #444444; font-weight: bold; }
 .formsmall    { font-family: Geneva, Arial, Helvetica, sans-serif; font-size: 8pt; color: #444444;  }
 A:link{text-decoration: none; color: #39597D;}
 A:visited{text-decoration: none; color: #1C395B;}
 A:active{text-decoration: underline; color: #1C395B; font-weight: bold;}
 A:hover{text-decoration: underline; color: #1C395B;}
</style>
</head>
<body topmargin=10 leftmargin=20 marginheight=10" marginwidth=20>
<table width=702 cellpadding=0 cellspacing=0 border=0>
<tr>
<td width=1 bgcolor=#BABABA><img src=tr.gif width=1 height=1></td>
<td width=700>
<table width=700 cellpadding=0 cellspacing=0 border=0>
<tr>
<td bgcolor=#BABABA height=1><img src=tr.gif height=1 width=1></td>
</tr>
<tr>
<td bgcolor=#EAEAEA>&nbsp;<span class=title>Customer Info</span></td>
</tr>
<tr>
<td bgcolor=#BABABA height=1><img src=tr.gif height=1 width=1></td>
</tr>
<tr>
<td>
<table width=700 cellpadding=0 cellspacing=0 border=0>
<tr><td width=120 bgcolor=#EAEAEA><br>
<ul>
<li><a href="../acmehosting.html">ACME Hosting</a></li>
<li><a href="shop.pl">ACME Store</a></li>
</ul>
</td>
<td width=1 bgcolor=#BABABA><img src=tr.gif width=1 height=1></td>
<td width=579 align=center>
<br>
EOT
}

sub footer {
print <<EOT;
</td></tr></table>
</td>
</tr>
<tr>
<td bgcolor=#BABABA height=1><img src=tr.gif height=1 width=1></td>
</tr>
</table></td>
<td width=1 bgcolor=#BABABA><img src=tr.gif width=1 height=1></td>
</tr></table>
</body>
</html>
EOT
}

sub init {
  if (!aolapi::init()) {
    print "<b>Unable to initialize aolapi</b>";
    footer();
    exit;
  }
  my @args = split(/&/, $ENV{'QUERY_STRING'});
  foreach my $arg (@args) {
    my ($name, $value) = split(/=/, $arg);
    $value =~ s/%0D%0A/\n/g;
    $value =~ s/%0A%0D/\n/g;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    if ($INPUT{$name} eq undef) {$INPUT{$name} = $value;}
    else { $INPUT{$name} .= "=and=$value"}
  }
}