#!/usr/bin/perl

use strict;
require 5.003;
use Socket;
use FindBin;
use lib $FindBin::Bin;
 if ($ENV{'WINDIR'} ne undef) { chdir($FindBin::Bin); }

use aolapi;

aolapi::init();

my %vars                = aolapi::getvars();
my $submit_button_text  = "Check domain name";
my $default_search_text = "domain-name";
my $availabletext       = "<font color=#ff0000>is available</font>";
my $unavailabletext     = "<font color=#ff0000>is unavailable</font>";
my $scriptname          = $ENV{SCRIPT_NAME};
my $filename            = "whois.html";
my $datafilename        = "data.txt";
my $tldprod             = "tldprod.txt";
my $defaultprodid       = "acmedomain";


####################################
# Any changes below are unsupported.
####################################

my @tophosts   = ();
my @servers    = ();
my $results    = "";
my $error      = "";

open (DATAFILE,$datafilename) or printerror("Cannot open $datafilename");
my @lines = <DATAFILE>;
close(DATAFILE);

 foreach (@lines)
 {
   if(/^([\w\W]+?)\|([\w\W]+?)(\r|\n)*$/)
   {
     if($2 !~ /^--/)
     {
      push(@tophosts,$1);
      push(@servers,$2);
     }
   }
 }

my %query    = get_data();
my $template = "$vars{basedir}/tmpl/$query{'template'}" if $query{'template'} ne undef;

open(TEMPLATE,$template) or printerror("Cannot open $template");
my $template_content = join("",<TEMPLATE>);
close(TEMPLATE);

my $dropdownlist;
$dropdownlist = "<select size=1 name=tophost>";
 for(my $i=0;$i<@tophosts;$i++)
 {
  my $selected = "selected" if($query{tophost} == $i);
  $dropdownlist .= "<option value=$i $selected>$tophosts[$i]</option>\n";
 }
$dropdownlist .= "</select>";


 if($query{fqdn} ne "") { $default_search_text = $query{fqdn}; }

$results .= "<form action=$scriptname method=post><input type=text name=fqdn value=\"$default_search_text\" size=25>\n";
$results .= "<input type=hidden name=template value=$query{template}>";
$results .= $dropdownlist;
$results .= "<input type=submit name=submit value=\"$submit_button_text\"><\/form><br>\n";
$results .= "**domain search results**";

 if($query{fqdn} eq "") { print_html(); }

$query{fqdn} =~ s/^http\:\/\///;
$query{fqdn} =~ s/^www\.//;
$query{fqdn} =~ tr/A-Z/a-z/;
$query{fqdn} =~ s/^\s+|\s*\n$//g;
$query{fqdn} =~ s/[^a-z0-9\-]//g;
$query{fqdn} =~ s/\--+/-/g;
$query{fqdn} =~ s/^\-//;
$query{fqdn} =~ s/\-$//;

 if($query{fqdn} eq "") { print_html(); }

my $whois_server = $servers[$query{tophost}];

my $fqdn = $query{fqdn}.$tophosts[$query{tophost}];
checkdomain();

print_html();

exit;

sub checkdomain
{
 my $port  = getservbyname('whois','tcp');
 my $iaddr = inet_aton($whois_server) || die printerror("No such host: $whois_server");
 my $paddr = sockaddr_in($port, $iaddr);
 my $proto = getprotobyname('tcp');
 socket(SOCK, PF_INET, SOCK_STREAM, $proto) || die printerror("Socket: $!");
 connect(SOCK, $paddr) || die printerror("$! $whois_server");
 select SOCK;
 $| = 1;
 print SOCK "$fqdn\015\012";
 select STDOUT;

 my $available;
  while(my $line = <SOCK>)
  {
    if ($line =~ /No entries|not a registered domain|No match|We do not have|No entries found|Not found|No Records|not registered|No data found|No Encontradas|Your search returns/i)
    { $available = "yes"; }
   $results .= "<font size=-2>$line</font><br>\r";
    if ($line =~ /Whois Server: whois./)
    {
     $whois_server = $line;
     $whois_server =~s/Whois Server: //;
     $whois_server =~ s/^\s+|\s*\n$//g;
     $results .= "<p><b>**Going to $whois_server for full record.**</b><p>";
     checkdomain();
    }
  }
 close (SOCK);

  if ($available eq "yes")
  {
   my $prodid = $defaultprodid;
    if(-e $tldprod)
    {
     open(PRODS,$tldprod);
     flock(PRODS,2);
     my @lines = <PRODS>;
     close(PRODS);
      for my $line (@lines)
      {
       $line =~ s/(\n|\r|\s)*$//;
       my($tld,$prod) = split(/\|/,$line);
       $prodid = $prod if($tophosts[$query{tophost}] eq $tld);
      }
    }
   $results =~ s/\*\*domain search results\*\*/<p align=center>$fqdn $availabletext<p><div align=center>
   <form action=cart.pl method=post>
   <input type=hidden name=cmd value=add>
   <input type=hidden name=prodid value=\"$prodid\">
   <input type=hidden name=notes value=\"$fqdn\">
   <input type=hidden name=template value=acmehostingextras.html>
   <input type=submit value=\"Add $fqdn to Cart\">
<!--   <form action=$vars{accview} method=post>
   <input type=hidden name=cmd value=loadtmpl>
   <input type=hidden name=custom1 value=\"$fqdn\">
   <input type=hidden name=template value=acmehostingnewaccnt.html>
   <input type=submit value=\"Create or Update your account with this domain name\">
-->
   <\/form><\/div>/;
  }
  else { $results =~ s/\*\*domain search results\*\*/<p align=center>$fqdn $unavailabletext<p>/; }
}


sub print_html
{
 $results =~ s/\*\*domain search results\*\*//;
 $template_content =~ s/\*\*WHOIS SERVICE\*\*/$results/;
 print "Content-Type: text/html\n\n";
 print $template_content;
 exit;
}

sub get_data
{
  my %query;
  my $buffer = $ENV{'QUERY_STRING'};
  my @pairs  = split(/&/, $buffer);
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  @pairs  = (@pairs, split(/&/, $buffer));
  foreach (@pairs) {
    my ($name,$value) = split(/=/);
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $query{$name} = $value;
  }
  return %query;
}


sub printerror
{
 print "Content-Type: text/html\n\n";
 print "<font face=\"Arial, Helvetica, sans-serif\" color=#FF0000 size=3><b>An error has occured: $_[0]</b></font>\n";
 exit;
}